#include <iostream>
using namespace std;

struct elem{
	int ind;
	int val;
	elem* pun;
};

class VettoreSparso{
    elem *p0;
    int dim;

    // funzioni private di utilita'
    void distruggi();
    // mascheramento costruttore di copia e operatore di assegnamento
    VettoreSparso(const VettoreSparso &);
    VettoreSparso& operator=(const VettoreSparso &);

public:
    // PRIMA PARTE
    VettoreSparso(int d);
    void set(int v, int i);
    friend ostream & operator <<(ostream &, const VettoreSparso &);

    // SECONDA PARTE
    void visualizzaComeDenso()const;
    void reset(int i);
    VettoreSparso& operator *=(int k);
    ~VettoreSparso(){distruggi();};
};
