#include <iostream>
#include <cstdlib>
using namespace std;

struct elem{
	int ind;
	int val;
	elem* pun;
};

class VettoreSparso{
  elem *p0;
  int dim;

  // funzioni private di utilita'
  void distruggi();
  void copia(const VettoreSparso &s);

public:
  // PRIMA PARTE
  VettoreSparso(int d);
  void set(int v, int i);
  friend ostream & operator <<(ostream &, const
  VettoreSparso &);

  // SECONDA PARTE
  void visualizzaComeDenso()const;
  void reset(int i);
  VettoreSparso& operator *=(int k);
  ~VettoreSparso(){distruggi();};
  
  // TERZA PARTE
  VettoreSparso(const VettoreSparso &);
  VettoreSparso& operator=(const VettoreSparso &);
  int get(int)const;
  int length()const{return dim;};
  int operator[](int ind)const{return get(ind);};
  // int& operator[](int);  // questo non ha senso implementarlo
};
